Expand the statistics line displayed at the end to include information
about exactly which repositories failed and were skipped, if any.
+=item -n
+
+Just operate on the repository for the current directory, do not
+recurse into deeper repositories.
+
=back
=head1 FILES
=item skip
-If the "skip" parameter is set and its command returns nonzero, then B<mr>
+If the "skip" parameter is set and its command returns true, then B<mr>
will skip acting on that repository. The command is passed the action
name in $1.
=item chain
-If the "chain" parameter is set and its command returns nonzero, then B<mr>
+If the "chain" parameter is set and its command returns true, then B<mr>
will try to load a .mrconfig file from the root of the repository. (You
should avoid chaining from repositories with untrusted committers.)
=item deleted
-If the "deleted" parameter is set and its command returns nonzero, then
+If the "deleted" parameter is set and its command returns true, then
B<mr> will treat the repository as deleted. It won't ever actually delete
the repository, but it will warn if it sees the repository's directory.
This is useful when one mrconfig file is shared amoung multiple machines,
my $directory=getcwd();
my $verbose=0;
my $stats=0;
+my $no_recurse=0;
my %config;
my %knownactions;
my %alias;
"c|config=s" => sub { $ENV{MR_CONFIG}=abs_path($_[1]) },
"v|verbose" => \$verbose,
"s|stats" => \$stats,
+ "n|no-recurse" => \$no_recurse,
);
if (! $result || @ARGV < 1) {
die("Usage: mr [-d directory] action [params ...]\n".
my $d=$directory;
$dir.="/" unless $dir=~/\/$/;
$d.="/" unless $d=~/\/$/;
+ next if $no_recurse && $d ne $dir;
next if $dir ne $d && $dir !~ /^\Q$d\E/;
push @repos, [$dir, $topdir, $subdir];
}
$config{$topdir}{$subdir}{lib}."\n" : "";
if (exists $config{$topdir}{$subdir}{deleted}) {
- if (! -d $dir) {
- return;
+ my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
+ print "mr $action: running deleted test >>$test<<\n" if $verbose;
+ my $ret=system($test);
+ if ($ret != 0) {
+ if (($? & 127) == 2) {
+ print STDERR "mr $action: interrupted\n";
+ exit 2;
+ }
+ elsif ($? & 127) {
+ print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
+ }
}
- else {
- my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
- print "mr $action: running deleted test >>$test<<\n" if $verbose;
- my $ret=system($test);
- if ($ret != 0) {
- if (($? & 127) == 2) {
- print STDERR "mr $action: interrupted\n";
- exit 2;
- }
- elsif ($? & 127) {
- print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
- }
- if ($ret >> 8 == 0) {
- print STDERR "mr error: $dir should be deleted yet still exists\n\n";
- push @failed, $dir;
- return;
- }
+ if ($ret >> 8 == 0) {
+ if (-d $dir) {
+ print STDERR "mr error: $dir should be deleted yet still exists\n\n";
+ push @failed, $dir;
+ return;
+ }
+ else {
+ print "mr $action: $dir skipped (as deleted) per config file\n" if $verbose;
+ push @skipped, $dir;
+ return;
}
}
}
print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
exit 1;
}
- if ($ret >> 8 == 0) {
- print "mr $action: $dir skipped per config file\n" if $verbose;
- push @skipped, $dir;
- return;
- }
+ }
+ if ($ret >> 8 == 0) {
+ print "mr $action: $dir skipped per config file\n" if $verbose;
+ push @skipped, $dir;
+ return;
}
}
fi
echo "Registering bzr url: $url"
mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
+ elif [ -d CVS ]; then
+ repo=$(cat CVS/Repository)
+ root=$(cat CVS/Root)
+ if [ -z "$root" ]; then
+ error "cannot determine cvs root"
+ fi
+ echo "Registering cvs repository $repo at root $root"
+ mr -c "$MR_CONFIG" config "$(pwd)" \
+ checkout="cvs -d '$root' co -d $basedir $repo"
else
error "unable to register this repo type"
fi